\subsection{\tt UnitTest}

The {\tt UnitTest} class, defined in {\tt unittest.h}, is the implementation of the mandatory testing structure.  All test files should follow the pattern below:
\begin{verbatim}
#include "unittest.h"

// include other headers

UnitTest Test; // global instantiation of test class

void TestSomething()
{
    Test.Message() << "Testing Something\n"; // optional
    
    // compute something that should be true
    
    Test.Check(something) << "Something\n";
    
    // more tests
    
}

void TestException()
{
    Test.Message() << "Testing Exception\n"; // optional
    
    try
    {
        // do something that should throw an Exception
        
        Test.Check(false) << "Exception (no throw)\n";
    }
    catch(const Exception&)
    {
        Test.Check(true) << "Exception\n";
    }
    catch(...)
    {
        Test.Check(false) << "Exception (wrong throw)\n";
    }
    
    // more tests
}

// more test functions

void ReplacementUnexpectedHandler()
{
    Test.Message() << "Exception specification violation\n";
    throw bad_exception();
}

int main(int argc, char** argv)
{

    Test.Init(argc, argv); // initialise with command line
    Test.Message(false) << "$Id: handbookTestCode.tex,v 1.1 2001/04/26 01:43:48 ldas_anu Exp $\n"; // file identifier
    
    std::set_unexpected(ReplacementUnexpectedHandler);
    
    try
    {
        TestSomething();
        TestError();
    
        // more test functions
    }
    catch(...)
    {
        Test.Check(false) << "Unexpected exception\n";
    }
    Test.Exit(); // returns 0 (pass), or 1 (fail) if any Check was false.
}
\end{verbatim}
\subsection{Classes}
Each class {\tt MyClass} defined in {\tt MyClass.*} must be tested in a correspoinding {\tt tMyClass.cc}.  The test code must check:
\begin{itemize}
	\item Correct behaviour for valid input.
  \begin{itemize}
	  \item Numerical accuracy (if applicable).
	  \item Correct output for typical input.
	  \item Correct output for marginal input.
	  \begin{itemize}
	    \item Input parameter(s) lie(s) at or near the boundary of valid range.
	    \item Input has atypically large dynamic range.
	  \end{itemize}
  \end{itemize}
	\item Correct behaviour for invalid input.
	  \begin{itemize}
	    \item Correct exception thrown.  
	  \end{itemize}
\end{itemize}
Every method of the class should be subjected to the applicable tests above.  Where there are several control flow paths through a method, each should be tested at least once, and if applicable near the boundaries of the switch for that path.  When a class or method is templatised, each instantiation type should be tested (this can often be wholly or partly done with templatised test code).
\subsection{Actions}
Test code for actions follows the principles above.  All control flow paths through the {\tt Function::Eval} method should be checked; this corresponds to checking all syntaxes of the action on all their supported types and checking exceptions are thrown for unsupported syntaxes or unsupported input types.  It is not necessary to dupicate correctness testing undertaken for the {\tt datacondAPI} class(es) used by the action, but any numerical proceedures undertaken by the action itself should be tested.

To test the {\tt Function::Eval} method it is necessary to construct a {\tt CallChain} and populate it with actions.  In operation mode this is the job of the Tcl job parser.  For testing, we use a ``sandbox'' {\tt CallChain} and append actions to it using its methods.